#---------------------------------------------------------------------------
# Singapore, 21st October 2011

# ACADEMIC SOFTWARE LICENSE for TMSOC
# ***********************************

# Copyright:
# Wing-Cheong Wong, Sebastian Maurer-Stroh, Frank Eisenhaber
# Bioinformatics Institute (BII) A*STAR Singapore

# This software is subjected to license restrictions. The software is
# provided as is. In its present form and without written consent of 
# the copyright holder, the software is provided in accordance with GPL
# (www.gnu.org/licenses/gpl.html). Among other issues, this excludes any
# warranty and indemnity when using this software. For a commercial license,
# please approach the authors (via email to wongwc@bii.a-star.edu.sg).

# When publishing results with this software, please refer to:
# Wing-Cheong Wong, Sebastian Maurer-Stroh, Frank Eisenhaber, 2011, 
# "Not all transmembrane helices are born equal: Towards the extension of 
# the sequence homology concept to the membrane proteins", Biology Direct

# When observing bugs or strange behavior of the software, the user is 
# encouraged to contact the authors.

#---------------------------------------------------------------------------
#!/usr/bin/perl
#use warnings;
#use strict;	# Forces variables to be declared

use lib '/home/TMcomplex/application';
use generateTMclassification;

$TMregions = "138,160 164,186";	# Assumes that the first position starts from 0
$FASTAseq = "VAEKAKDERELLEKTSELIAGMGDKIGEHLGDKYKAIAKDIADNIKNFQGKTIRSFDDAMASLNKITANPAMKINKADRDALVNAWKHVDAQDMANKLGNLSKAFKVADVVMKVEKVREKSIEGYETGNWGPLMLEVESWVLSGIASSVALGIFSATLGAYALSLGVPAIAVGIAGILLAAVVGALIDDKFADALNNEIIRPAH";

#2.21414759479338,0.213755613572032	
#-2.008,1.73266730793883	
#-2.732,0.755788330156001	
#0.69,1.07517440445725

#1.55614774437442,0.1617350628322	
#-1.842,1.01955676644314	
#-0.852,0.488647111932528	
#-1.046,0.623782013206537

$FASTAseq =~ s/\r//g;	# remove linefeed
$FASTAseq =~ s/\n//g;	# remove linefeed
$FASTAseq =~ s/\s+//g;	# remove white spaces

my $resultsRef;
my @results;
my $newFASTAseq;
($resultsRef, $newFASTAseq) = generateTMclassification($TMregions, $FASTAseq);
@results = @$resultsRef;

my $i;
print "TMsequence;TMrange;Complexity;Hydrophobicity;Zscore;Classification\n";
for ($i=0; $i<scalar(@results); $i++) {
	print $results[$i]."\n\n";
}

print "Input sequence\n".$FASTAseq."\nMasked sequence\n".$newFASTAseq."\n";